unit DD79u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

const ver='09 Dec 2009';

function Out32(wAddr:word;bOut:byte):byte; stdcall; external 'inpout32.dll';

type
  TDD79f1 = class(TForm)
    paTickBoxes: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    buQuit: TButton;
    paChoice: TPanel;
    rbSlider: TRadioButton;
    RadioButton2: TRadioButton;
    cbEnHW: TCheckBox;
    laTickTotal: TLabel;
    paScrollBar: TPanel;
    laByScroll: TLabel;
    ScrollBar1: TScrollBar;
    laTxtTickTot: TLabel;
    laTxtByScroll: TLabel;
    laTxtGetStarted: TLabel;
    laTxtWarn1: TLabel;
    buWarn: TButton;
    laSource: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure rbSliderClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure buWarnClick(Sender: TObject);
    procedure cbEnHWClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    PPAddr:integer;
    bValue:byte;
    boBit:array[0..7] of boolean;
    boNotShownYet:boolean;
    function CalcValue:byte;
    procedure UpdateValue(bTmp:byte);
    
  end;

var
  DD79f1: TDD79f1;

implementation

uses DD79u2;

{$R *.DFM}

procedure TDD79f1.FormCreate(Sender: TObject);
begin
dd79f1.caption:='DD79 from SheepdogGuides.com, version: '+ver;
application.title:='DD79';
boNotShownYet:=true;
laTickTotal.caption:='0';
laByScroll.caption:='';
PPAddr:=$378;//right for pcSia
end;

procedure TDD79f1.UpdateValue(bTmp:byte);
//var bErr:byte;
begin
laTickTotal.caption:=inttostr(bTmp);
if cbEnHW.checked then Out32(PPAddr,bTmp);
end;

function TDD79f1.CalcValue:byte;
var bTmp:byte;
begin
bTmp:=0;
if boBit[7]then bTmp:=bTmp+128;
if boBit[6]then bTmp:=bTmp+64;
if boBit[5]then bTmp:=bTmp+32;
if boBit[4]then bTmp:=bTmp+16;
if boBit[3]then bTmp:=bTmp+8;
if boBit[2]then bTmp:=bTmp+4;
if boBit[1]then bTmp:=bTmp+2;
if boBit[0]then bTmp:=bTmp+1;
result:=bTmp;
end;

procedure TDD79f1.buQuitClick(Sender: TObject);
begin
application.terminate;
end;

procedure TDD79f1.CheckBox1Click(Sender: TObject);
begin
if CheckBox1.checked then boBit[7]:=true else boBit[7]:=false;
UpdateValue(CalcValue);
end;

procedure TDD79f1.CheckBox2Click(Sender: TObject);
begin
if CheckBox2.checked then boBit[6]:=true else boBit[6]:=false;
UpdateValue(CalcValue);
end;

procedure TDD79f1.CheckBox3Click(Sender: TObject);
begin
if CheckBox3.checked then boBit[5]:=true else boBit[5]:=false;
UpdateValue(CalcValue);
end;

procedure TDD79f1.CheckBox4Click(Sender: TObject);
begin
if CheckBox4.checked then boBit[4]:=true else boBit[4]:=false;
UpdateValue(CalcValue);
end;

procedure TDD79f1.CheckBox5Click(Sender: TObject);
begin
if CheckBox5.checked then boBit[3]:=true else boBit[3]:=false;
UpdateValue(CalcValue);
end;

procedure TDD79f1.CheckBox6Click(Sender: TObject);
begin
if CheckBox6.checked then boBit[2]:=true else boBit[2]:=false;
UpdateValue(CalcValue);
end;

procedure TDD79f1.CheckBox7Click(Sender: TObject);
begin
if CheckBox7.checked then boBit[1]:=true else boBit[1]:=false;
UpdateValue(CalcValue);
end;

procedure TDD79f1.CheckBox8Click(Sender: TObject);
begin
if CheckBox8.checked then boBit[0]:=true else boBit[0]:=false;
UpdateValue(CalcValue);
end;

procedure TDD79f1.ScrollBar1Change(Sender: TObject);
begin
if cbEnHW.checked then Out32(PPAddr,scrollbar1.position);
laByScroll.caption:=inttostr(scrollbar1.position);
end;

procedure TDD79f1.rbSliderClick(Sender: TObject);
begin
paTickBoxes.enabled:=false;
paScrollbar.enabled:=true;
laTxtGetStarted.caption:='';
laTxtTickTot.caption:='';
laTickTotal.caption:='';
laTxtByScroll.caption:='Value, set by scrollbar:';
laByScroll.caption:=inttostr(scrollbar1.position);
ScrollBar1Change(Self);
end;

procedure TDD79f1.RadioButton2Click(Sender: TObject);
begin
paScrollbar.enabled:=false;
paTickBoxes.enabled:=true;
laTxtGetStarted.caption:='';
laTxtTickTot.caption:='Total from the ticks:';
laTickTotal.caption:=inttostr(CalcValue);
laTxtByScroll.caption:='';
laByScroll.caption:='';
UpdateValue(CalcValue);
end;

procedure TDD79f1.buWarnClick(Sender: TObject);
begin
dd79f2.show;
end;

procedure TDD79f1.cbEnHWClick(Sender: TObject);
begin
if boNotShownYet then showmessage('The outputs will reflect what is shown on the screen as soon '+
   'an input channel is designated.');
boNotShownYet:=false;
end;

end.
